%bcond_without compat

%if %{with compat}
%global lua_compat_version 5.1
%global lua_compat_libdir %{_libdir}/lua/%{lua_compat_version}
%global lua_compat_builddir %{_builddir}/compat-lua-%{name}-%{version}-%{release}
%endif

%global versiontag 1.8.0
%global gittag %(echo %{versiontag} | sed -e 's/\\./_/g')

Summary:        File System Library for the Lua Programming Language
Name:           lua-filesystem
Version:        %{versiontag}
Release:        6%{?dist}
License:        MIT
URL:            https://lunarmodules.github.io/luafilesystem/
Source0:        https://github.com/keplerproject/luafilesystem/archive/v%{gittag}/luafilesystem-%{version}.tar.gz

BuildRequires:  make gcc
BuildRequires:  lua-devel >= 5.1
%if %{with compat}
BuildRequires:  compat-lua >= %{lua_compat_version} compat-lua-devel >= %{lua_compat_version}
%endif

%description 
This package provides a Lua library developed to complement the set of functions related to 
file systems offered by the standard Lua distribution.

It offers a portable way to access the underlying directory structure and file attributes.

%if %{with compat}
%package -n lua%{lua_compat_version}-filesystem
Summary:        File System Library for the Lua Programming Language %{lua_compat_version}
Provides:       lua-filesystem-compat = %{version}-%{release}

%description -n lua%{lua_compat_version}-filesystem 
This package provides a Lua library developed to complement the set of functions related to 
file systems offered by the standard Lua distribution.

It offers a portable way to access the underlying directory structure and file attributes.
%endif


%prep
%autosetup -n luafilesystem-%{gittag}

%if %{with compat}
rm -rf %{lua_compat_builddir}
cp -a . %{lua_compat_builddir}
%endif

%build
%make_build LUA_LIBDIR=%{lua_libdir} CFLAGS="%{optflags} -fPIC %{?__global_ldflags}"

%if %{with compat}
pushd %{lua_compat_builddir}
%make_build LUA_LIBDIR=%{lua_compat_libdir} CFLAGS="-I%{_includedir}/lua-%{lua_compat_version} %{optflags} -fPIC %{?__global_ldflags}"
popd
%endif

%install
%make_install LUA_LIBDIR=%{lua_libdir}

%if %{with compat}
pushd %{lua_compat_builddir}
%make_install LUA_LIBDIR=%{lua_compat_libdir}
popd
%endif

%check
LUA_CPATH=%{buildroot}%{lua_libdir}/\?.so lua tests/test.lua

%if %{with compat}
LUA_CPATH=%{buildroot}%{lua_compat_libdir}/\?.so lua-%{lua_compat_version} tests/test.lua
%endif

%files
%license LICENSE
%doc README.md doc/us/*
%{lua_libdir}/*

%if %{with compat}
%files -n lua%{lua_compat_version}-filesystem
%license LICENSE
%doc README.md doc/us/*
%{lua_compat_libdir}/*
%endif

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 22 2023 Wang Guodong <gordonwwang@tencent.com> - 1.8.0-1
- initial build
